/* $Id: jcor.java,v 1.21 2017/11/01 07:18:17 mit3 Exp $ */
/* jcor.java v0.1 */
import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.text.DecimalFormat;

public class jcor extends Applet
    implements ActionListener, AdjustmentListener, ItemListener,
	       MouseListener, MouseMotionListener
{
    final int KB = 88;
    final int OCTAVE = 12;
    final int CENT12 = 1200;
    //
    final int CENT = 0;
    //final int INHA = 1;
    final int IG_ = 1;
    final int OCT2 = 2;
    final int CORR = 3;
    final int R_ = 4;
    //
    final double REVOCT = 1.0/OCTAVE;
    final String[] Graph = {"Cent", "IG", "2Oct.", "Corr.", "R"}; //"Inha."
    final String[] Octnm = {"A2","A1","A","a","a1","a2","a3","a4"};
    final String[] KeyName =
    {"A..","B..","H..","C..","Cis","D..","Es.","E..","F..","Fis","G..","Gis"};
    private static final long serialVersionUID = 1L;

    private Button[] btGraph;
    private Button btPlus;
    private Button btMinus;
    private Button btPol;
    private Scrollbar scrVert;
    private Scrollbar scrHori;
    private Scrollbar scrZoomV;
    private Scrollbar scrZoomH;
    private Label lbVert;
    private Label lbHori;
    private Label lbZoomV;
    private Label lbZoomH;
    private TextField tfData;
    private Choice chA;
    private Canvas can;
    private Panel PN, PE, PW, PS;

    private Graphics gi;
    private Image ig;
    private Font Fnt;
    private FontMetrics fm;
    private DecimalFormat df1;

    private int W, H, W2, H2;
    private int FONT;
    private int GRPH;
    private int WOUND = 28-1;
    private int DOT, SFT;
    private int Cmax, C2;
    private int Bmax;
    private int KEY = 37-1;
    private int AllF;
    private int AllData;
    private int AllCorr;
    private int CorrCNT;
    private int CentCNT;

    private double DX, DY;
    private double HB;
    private double MouseX;
    private double RR;
    private double A49I = 0.55;
    private double Grade = 0.087;
    private double GradeBass = 0.07;
    private double lsmA, lsmB;
    private double HORI;
    private double VERT;
    private double ZOOMV;
    private double ZOOMH;
    private String DirName;
    private String Error = "";
    private double[] Inha = new double[KB]; // ɽ
    private double[] Cent = new double[KB]; // "
    private String[] FileName;
    private KeyData[] KD;
    private KeyData[] KdSort; 
    private KeyData[][] KC;
    private IGData[] IG;
    private double[] R;
    private double[] Y;
    private boolean CorrSW;
    private boolean MouseSW;
    private boolean PolSW;
    
    public void init() {
        String fnt = getParameter("font");
        FONT = (fnt != null) ? Integer.parseInt(fnt) : 12;
        Fnt = new Font("SansSerif", Font.PLAIN, FONT);
        setFont(Fnt);
        fm = getFontMetrics(Fnt);
        df1 = new DecimalFormat("#0.0##");

        buildLayout();

        Cmax = 80;
        GRPH = CENT;
	initInha();
	initCent();

	read_corr("igdata");
	CorrCNT = getAllData();
	read_data(chA.getItem(0));
    }
    public void buildLayout() {
        setBackground(Color.lightGray);
        setLayout(new BorderLayout());

        PW = new Panel();
        PW.setLayout(new GridLayout(Graph.length,1,0,0));
        add(PW, "West");

        btGraph = new Button[Graph.length];
        for (int i = 0; i < Graph.length; i++) {
            btGraph[i] = new Button(Graph[i]);
            btGraph[i].addActionListener(this);
            PW.add(btGraph[i]);
        }
	//
        PE = new Panel();
        PE.setLayout(new GridLayout(4,1,0,0));
        add(PE, "East");

        btPlus = new Button("+");
        btPlus.addActionListener(this);
        PE.add(btPlus);

        btMinus = new Button("-");
        btMinus.addActionListener(this);
        PE.add(btMinus);

        btPol = new Button("P");
        btPol.addActionListener(this);
        PE.add(btPol);
	//
        PN = new Panel();
        PN.setLayout(new FlowLayout());
        add(PN, "North");

	tfData = new TextField(26);
        tfData.setEditable(false);
        PN.add(tfData);

	String fn = getParameter("allFile");
        AllF = (fn == null) ? 0 : Integer.parseInt(fn);
        if (AllF == 0)
            Error = "No wave file.";
        FileName = new String[AllF];  // max files  
        DirName = getParameter("dirnm");
        DirName = (DirName == null) ? "" : DirName;
	chA = new Choice();
	for (int i = 0; i < AllF; i++) {
            FileName[i] = getParameter("data"+i);
            chA.addItem(FileName[i]);
        }
        chA.addItemListener(this);
	PN.add(chA);
	//
        PS = new Panel();
        PS.setLayout(new GridLayout(4,2,0,0));
        add(PS, "South");

	scrVert = new Scrollbar(Scrollbar.HORIZONTAL, 40, 1, 0, 101);
	scrVert.addAdjustmentListener(this);
	PS.add(scrVert);

	lbVert = new Label("Vert: ", Label.LEFT);
	PS.add(lbVert);

	scrHori = new Scrollbar(Scrollbar.HORIZONTAL, 80, 20, 50, 100);
	scrHori.addAdjustmentListener(this);
	PS.add(scrHori);

	lbHori = new Label("Grade: ", Label.LEFT);
	PS.add(lbHori);

	scrZoomV = new Scrollbar(Scrollbar.HORIZONTAL, 200, 1, 100, 201);
	scrZoomV.addAdjustmentListener(this);
	PS.add(scrZoomV);

	lbZoomV = new Label("ZoomV: ", Label.LEFT);
	PS.add(lbZoomV);

	scrZoomH = new Scrollbar(Scrollbar.HORIZONTAL, 200, 1, 100, 301);
	scrZoomH.addAdjustmentListener(this);
	PS.add(scrZoomH);

	lbZoomH = new Label("ZoomG: ", Label.LEFT);
	PS.add(lbZoomH);
        //
        can = new myCanvas();
        add(can, "Center");

	can.addMouseListener(this);
        can.addMouseMotionListener(this);
    }
    public void start() {
        W = getCanvasD().width;
        H = getCanvasD().height;
        W2 = W/2;
        H2 = H/2;
        can.setSize(W, H);
        ig = createImage(W, H);
        gi = ig.getGraphics();
        gi.setFont(Fnt);

	DX = (double)W/KB;
	HB = H/10.0;
	initDot();

	setVert();
	setHori();
	setZoomV();
	setZoomH();
    }
    public Dimension getCanvasD() {
        Dimension dn = PN.getSize();
        Dimension de = PE.getSize();
        Dimension ds = PS.getSize();
        Dimension dw = PW.getSize();
        Dimension da = getSize();
        int cw = da.width-(de.width+dw.width);
        int ch = da.height-(dn.height+ds.height)-5;
        Dimension can = new Dimension(cw, ch);

        return can;
    }
    public String dform(double n) {
        return df1.format((float)n);
    }
    public void initDot() {
        DOT = (int)((double)W/KB);
        if (DOT < 2)
            DOT = 2;

        SFT = DOT/2;
    }
    public void initCent() {
        for (int i = 0; i < KB; i++)
            Cent[i] = 0;
    }
    public void initInha() {
	for (int j = WOUND; j < KB; j++) {
	    Inha[j] = Math.exp(j * Grade);
	}
	double df = A49I / Inha[48];
	double db = (Inha[WOUND] * df) / make_bass_curve(WOUND);
	for (int i = 0; i < KB; i++) {
	    if (i <= WOUND)
		Inha[i] = make_bass_curve(i) * db;
	    else
		Inha[i] *= df;
	}
    }
    public double make_bass_curve(int key) {
	return cosh(GradeBass * (key - WOUND));
    }
    public double cosh(double x) {
	 double me = Math.pow(Math.E, x);

	 return (me+1/me) / 2;
    }
    //
    public void read_corr(String file) {
	try {
            URL url = new URL(getDocumentBase(), DirName+file);
	    ReadCorr rc = new ReadCorr(url);

	    AllCorr = ReadCorr.getAllData();
	    IG = new IGData[AllCorr];
	    IG = ReadCorr.getData();
	    Error = ReadCorr.getError();
	} catch(Exception e) {
            Error ="IGdata File read error.";
        }
    }
    public void read_data(String file) {
        try {
            URL url = new URL(getDocumentBase(), DirName+file); //
            ReadData rd = new ReadData(url);

	    AllData = ReadData.getAllData();
	    //System.out.println("ad: "+AllData);
	    KD = new KeyData[AllData];
	    KD = ReadData.getData();
	    Error = ReadData.getError();
        } catch(Exception e) {
            Error ="Data File read error.";
        }

	sortKey();
	selectData();
    }
    //
    public void mouseMoved(MouseEvent me) {
	if (MouseSW) {
            KEY = (int)(me.getX()/DX);
        }

	can.repaint();
    }
    public void mouseDragged(MouseEvent me) {}
    public void mousePressed(MouseEvent m) {
	MouseSW = !MouseSW;
	can.repaint();
    }
    public void mouseClicked(MouseEvent m) {}
    public void mouseReleased(MouseEvent m){}
    public void mouseEntered(MouseEvent m) {}
    public void mouseExited (MouseEvent m) {}
    //
    public void actionPerformed(ActionEvent e) {
	int cnt;
        for (int i = 0; i < Graph.length; i++) {
            if (e.getSource() == btGraph[i]) {
                GRPH = i;
		if (GRPH == CENT) {
		    CentCNT++;
		    if (CentCNT > 2) // 3->2
			CentCNT = 0;
		}
                break;
            }
        }
	if (e.getSource() == btPlus)
            set_gain(true);
        else if (e.getSource() == btMinus)
            set_gain(false);
	else if (e.getSource() == btPol)
	    set_pol();

	can.repaint();
    }
    public void set_pol() {
	PolSW = !PolSW;
    }
    public void set_gain(boolean sw) {
        switch (GRPH) {
        case CENT:
	case OCT2:
            Cmax = sw ? Cmax*2 : Cmax/2;
            if (Cmax < 1)
                Cmax = 1;
            break;
        }
    }
    //
    public void adjustmentValueChanged(AdjustmentEvent e) {
	if (e.getSource() == scrVert)
	    setVert();
	if (e.getSource() == scrHori)
	    setHori();
	if (e.getSource() == scrZoomV)
	    setZoomV();
	if (e.getSource() == scrZoomH)
	    setZoomH();

        can.repaint();
    }
    public void setVert() {
	VERT = scrVert.getValue()/100.0;
	String str = (GRPH == IG_) ? "Inha." : "Vert"; //
	lbVert.setText(str+": "+dform(VERT));
    }
    public void setHori() {
	HORI = scrHori.getValue()/1000.0;
	lbHori.setText("Grade: "+dform(HORI));
    }
    public void setZoomV() {
	ZOOMV = scrZoomV.getValue()/100.0;
	String str = (GRPH == IG_) ? "ZoomI" : "ZoomV";
	lbZoomV.setText(str+": "+dform(ZOOMV));
    }
    public void setZoomH() {
	ZOOMH = scrZoomH.getValue()/100.0;
	lbZoomH.setText("ZoomG: "+dform(ZOOMH));
    }
    //
    public void itemStateChanged(ItemEvent e) {
	if (e.getItemSelectable() == chA) {
	    read_data(chA.getSelectedItem());
	}

	can.repaint();
    }
    public void selectData() {
	int ind = chA.getSelectedIndex();
	A49I = IG[ind].getInha();
	Grade = IG[ind].getGrade();
	initInha();
    }
    //
    public void sortKey() {
	int k;
	int[] tmp = new int[KB+1];       // 1-88
	double[] val = new double[KB+1]; // "

	for (int i = 0; i < AllData; i++) { // ʬ
	    k = KD[i].getKey(); // lsm3ǻѤΰkeyϤΤޤ
	    tmp[k]++;                  // keyǥ
	    val[k] += KD[i].getCent(); // centι 1~88
	}

	int cnt = 0;
	KdSort = new KeyData[KB]; 
	for (int l = 1; l < KB+1; l++) { // centʿͤФ 0~87
	    if (tmp[l] > 0) {            // key
		KdSort[cnt] = new KeyData(l, val[l]/tmp[l]);
		cnt++;
	    }
	}
    }
    //
    class myCanvas extends Canvas {
        private static final long serialVersionUID = 1L;
        public void update (Graphics g) {
            can.paint(g);
        }
        public void paint(Graphics g) {
            paintI();
            g.drawImage(ig, 0, 0, this);
        }
    }
    public void paintI() {
	bgBlack(gi);
        DY = (double)H/Cmax;
        C2 = Cmax/2;

        switch (GRPH) {
	    //case INHA:
            //dispInha(gi);
            //break;
        case CENT:
	    dispCline(gi, SFT);
	    dispAline(gi);
	    dispCentLine(gi, SFT);

	    dispData1(gi);
	    dispKdSort(gi);
            break;
	case OCT2:
	    disp2octave(gi);
	    break;
	case CORR:
	    dispCorre(gi);
	    break;
	case R_:
	    dispR(gi);
	    break;
	case IG_:
	    dispIGdata(gi);
	    break;
	default:
            break;
        }
 
	write_tfdata();
    }
    public void write_tfdata() {
        StringBuffer sb = new StringBuffer(40);
        sb.append(getKeyname(KEY)+": ");
        sb.append(dform(calcFreq(1, KEY))+"[Hz]");

        switch (GRPH) {
	    //case INHA:
	    //sb.append(": "+dform(Inha[KEY]));
            //break;
        case CENT:
            //sb.append(": "+dform(Cent[KEY]));
            //sb.append("[cent]");
            break;
	case OCT2:
	    //
	    break;
	case R_:
	    if (Double.isNaN(RR))
		sb.append(": R= NaN");
	    else
		sb.append(": R="+dform(RR));
	    break;
	case CORR:
	    if (Double.isNaN(R[KEY]))
		sb.append(": R= NaN");
	    else
		sb.append(": R="+dform(R[KEY]));
	    break;
	default:
	    break;
        }

	String st = Error.equals("") ? sb.toString() : Error;
        tfData.setText(st);
    }
    public String getKeyname(int num) {
        return (num+1)+"("+getKey(num)+")";
    }
    public String getKey(int key) {
        return (key < 0) ? "" : KeyName[key%OCTAVE];
    }
    public void bgBlack(Graphics g) {
        g.setColor(Color.black);
        g.fillRect(0, 0, W, H);
    }
    //
    public void dispInha(Graphics g) {
        dispInhaLine(g);
        dispAline(g);

        for (int i = 0; i < KB; i++) {
	    mouseColor(g, i);
            g.fillOval((int)(i*DX),
                       (int)calc_inha(Inha[i]), DOT, DOT);
        }
    }
    public void mouseColor(Graphics g, int key) {
	if (key == KEY)
	    g.setColor(Color.green);
	else if (key <= WOUND)
	    g.setColor(Color.pink);
	else
	    g.setColor(Color.white);
    }
    public double calc_inha(double val) {
        return H2-Math.log(val)*HB;
    }
    public void dispInhaLine(Graphics g) {
        double h0 = 0.001, hl;
        double di = H/5.0;
        int hm;

        for (int i = 1; i < 6; i++) { // ʿ
            hl = h0*Math.pow(10, i);
            hm = (int)(SFT+H2-log_base(hl)*di);

            g.setColor(Color.blue);
            g.drawLine(0, hm, W, hm);

            g.setColor(Color.orange); // 
            g.drawString(""+(float)hl, 2, hm);
        }
    }
    public double log_base(double value) {
        return Math.log(value)/Math.log(10);
    }
    public void dispAline(Graphics g) {
        int x;

        for (int i = 0; i < KB; i += OCTAVE) {
            x = (int)(SFT+DX*i);

            g.setColor(Color.blue);
            g.drawLine(x, 0, x, H);

            g.setColor(Color.red);
            g.drawString(Octnm[i/OCTAVE], x, H-FONT);
        }
    }
    //
    public void dispKdSort(Graphics g) {
	if (CentCNT != 2 && CentCNT != 1)
	    return;

	int k;
	double ce;

	g.setColor(Color.magenta);
	for (int i = 0; i < KB; i++) {
	    if (KdSort[i] == null)
		continue;
	    k = KdSort[i].getKey()-1; // java˹碌 -1
	    ce = KdSort[i].getCent();
	    g.fillOval((int)(k*DX), (int)(H2-ce*DY), DOT, DOT);
	}
    }
    public void dispData1(Graphics g) {
	if (CentCNT != 0 && CentCNT != 1)
	    return;

	int k;
	double ce;

	g.setColor(Color.cyan);
	for (int i = 0; i < AllData; i++) {
	    k = KD[i].getKey()-1;
	    ce = KD[i].getCent();
	    g.fillOval((int)(k*DX), (int)(H2-ce*DY), DOT, DOT);
	}
    }
    //
    public void mouseColorCent(Graphics g, int key) {
	if (key == KEY)
	    g.setColor(Color.green);
	else
	    g.setColor(Color.white);
    }
    public void dispCline(Graphics g, int sft) {
        g.setColor(Color.gray);
        g.drawLine(0, H2+sft, W, H2+sft);
    }
    public void dispCentLine(Graphics g, int sft) {
        int hp, hm, len, hx = C2/5;
        String str;
        double hy, hi;

        for (int i = 1; i < 6; i++) {
            hi = hx*i;
            hy = hi*DY;
            hp = (int)(H2+hy+sft);
            hm = (int)(H2-hy+sft);

            g.setColor(Color.darkGray);
            g.drawLine(0, hm, W, hm);
            g.drawLine(0, hp, W, hp);

            g.setColor(Color.pink);
            str = ""+hi;
            len = fm.stringWidth(str);
            g.drawString(str, W-len, hm+FONT);
            str = "-"+hi;
            len = fm.stringWidth(str);
            g.drawString(str, W-len, hp);
        }
    }
    //
    public void disp2octave(Graphics g) {
	int startK = KEY;
	int endK = startK+2*OCTAVE;
	int keys = endK-startK;
	int ii, dot = 8;
	int sft = dot/2;
	//int dsft = sft;//-SFT;
	double dx = W/(double)keys;

	dispCline(g, sft);
	dispCentLine(g, sft);
	disp2octaveLine(g, startK, endK, sft);

	int k;
	double ce;
	int[] key = new int[KB];
	double[] cent = new double[KB];
	g.setColor(Color.magenta);
	for (int i = 0; i < KB ; i++) {
	    if (KdSort[i] == null)
		continue;

	    k = KdSort[i].getKey()-1;
	    if (k >= startK && k < endK) {
		ii = k-startK;
		ce = KdSort[i].getCent();
		cent[k] = ce;
		key[k] = k;

		g.fillOval((int)(ii*dx),
			   (int)(H2-ce*DY), dot, dot);
		//g.fillOval((int)(ii*dx-sft),
		//	   (int)(H2-ce*DY-dsft), dot, dot);
	    }
	}
	calcLSM(key, cent);

	double val;
	g.setColor(Color.white);
	for (int i = 0; i < keys; i++) {
	    ii = i+startK;
	    val = lsmA+lsmB*ii;
	    g.drawOval((int)(i*dx), (int)(H2-val*DY), dot, dot);
	    //g.drawOval((int)(i*dx-sft), (int)(H2-val*DY-dsft), dot, dot);
	}
    }
    public void disp2octaveLine(Graphics g, int startK, int endK, int sft) {
	int keys = endK-startK;
	int dh;
	double dx = W/(double)keys;

	for (int i = 0; i < keys; i++) {
	    dh = (int)(i*dx+sft);
	    g.setColor(Color.darkGray);
            g.drawLine(dh, 0, dh, H);

	    g.setColor(Color.orange);
	    g.drawString(getKey(i+KEY), dh, H-FONT);
	}
    }
    //
    public void calcLSM(int[] key, double[] cent) {
        double s1 = 0, s2 = 0, xb = 0, yb = 0;
        double y, z;
        int x, n = 0;
	lsmA = 0;
	lsmB = 0;
	for (int i = 0; i < KB; i++) {
	    if (key[i] < 1)
		continue;
            x = i+1;
	    y = cent[i];

            s1 += x*y;
            s2 += x*x;
            xb += x;
            yb += y;
            n++;
        }
        s1 /= n;
        s2 /= n;
        xb /= n;
        yb /= n;
	z = s2-xb*xb;
	lsmA = (s2*yb-s1*xb)/z;
        lsmB = (s1-yb*xb)/z;
    }
    public void dispCorre(Graphics g) {
	dispAline(g);
	dispCorreline(g);

	if (!CorrSW) {
	    calcCorre();
	}
	double dy = (PolSW) ? (double)H/2.0 : (double)H;
	int hh = (PolSW) ? H2 : 0;
	for (int i = 0; i < KB; i++) {
	    if (R[i] == 0)
		continue;
	    if (Double.isNaN(R[i])) {
		g.setColor(Color.red);
		g.fillOval((int)(i*DX), 0, DOT, DOT);
		continue;
	    } else if (i == KEY)
		g.setColor(Color.pink);
	    else
		g.setColor(Color.white);

	    g.fillOval((int)(i*DX), (int)(hh-R[i]*dy), DOT, DOT); 
	}
    }
    public void dispCorreline(Graphics g) {
	int h0, h1, h2;
	int hh = (PolSW) ? 5 : 10;
	double dy;
	double mh = 1.0/hh;
	double dh = (PolSW) ? (double)H2/hh : (double)H/hh;

	for (int i = 1; i < hh; i++) {
	    dy = i*dh;
	    if (PolSW) {
		h1 = (int)(H2-dy+SFT);
		g.setColor(Color.darkGray);
		g.drawLine(0, h1, W, h1);

		g.setColor(Color.lightGray);
		g.drawString(dform(mh*i), 1, h1);
	    }
	    h0 = (PolSW) ? (int)(H2+dy+SFT) : (int)(dy+SFT);
	    g.setColor(Color.darkGray);
	    g.drawLine(0, h0, W, h0);

	    g.setColor(Color.lightGray);
	    g.drawString("-"+dform(mh*i), 1, h0);
	}
	if (PolSW) {
	    h2 = H2+SFT;
	    g.setColor(Color.darkGray);
	    g.drawLine(0, h2, W, h2);

	    g.setColor(Color.lightGray);
	    g.drawString("0.0", 1, h2);
	}
    }
    //
    public void dispR(Graphics g) {
	dispRVline(g);
	dispRHline(g);

	calcR(KEY);
	if (IG == null)
	    return;

	double[] x = getIG(false); // grade
	double min = 0.08;
	double max = 0.1;
	double dif = max-min;
	MinMax mmx = new MinMax(x);
	double minx = mmx.getMin();
	double maxx = mmx.getMax();
	g.setColor(Color.pink);
	g.drawString("Grade:["+dform(minx)+"-"+dform(maxx)+"]", 1, FONT);

	if (Y == null)
	    return;
	MinMax mmy = new MinMax(Y);
	double miny = mmy.getMin();
	double maxy = mmy.getMax();
	double dify = maxy-miny;
	String str = Double.isNaN(miny) ? " ( NaN-NaN)" :
	    " ("+dform(miny)+"-"+dform(maxy)+")";
	g.setColor(Color.yellow);
	g.drawString(str, 1, FONT+FONT);

	calcCorrelation(x, Y);

	double dx = (double)W/(ZOOMH*dif);
	double dy = (double)H/(ZOOMV*dify);
	int x0, y0;

	g.setColor(Color.yellow);
	for (int i = 0; i < x.length; i++) {
	    x0 = (int)((x[i]-HORI)*dx);
	    y0 = (int)((maxy-Y[i]+(dify/2*VERT))*dy);
	    g.fillOval(x0, y0, DOT, DOT);
	}
    }
    public void dispRVline(Graphics g) {
	double min = 0.05;
	double max = 0.1;
	double x0;
	double dx = (double)W/(ZOOMH*0.02);
	int xx;

	for (int i = 0; i < 10; i++) {
	    x0 = min+i*0.01;
	    xx = (int)(dx*(x0-HORI)+SFT);
	    g.setColor(Color.darkGray);
            g.drawLine(xx, 0, xx, H);

	    g.setColor(Color.pink);
	    g.drawString(dform(x0), xx, H);
	}
    }
    public void dispRHline(Graphics g) {
	int dy, hh = 10;
	double mh = 1.0/hh;
	double dh = (double)H/hh;

	for (int i = 0; i < hh; i++) {
	    dy = (int)(i*dh);
	    g.setColor(Color.darkGray);
	    g.drawLine(0, dy, W, dy);
	}
    }
    //
    class MinMax {
	private double min = 100.0;
	private double max = 0.001;

	public MinMax() {}
	public MinMax(double[] x) {
	    calcMinMax(x);
	}
	public void calcMinMax(double[] x) {
	    int len = x.length;
	    for (int i = 0; i < len; i++) {
		min = Math.min(x[i], min);
		max = Math.max(x[i], max);
	    }
	}
	public double getMin() {
	    return min;
	}
	public double getMax() {
	    return max;
	}
	public String toString() {
	    StringBuilder str = new StringBuilder();
	    str.append("Min: ").append(min);
	    str.append(" Max: ").append(max);
	    return str.toString();
	}
    }
    public int getAllData() {
	int cnt = chA.getItemCount();
	KC = new KeyData[cnt][KB];
	for (int i = 0; i < cnt; i++) {
	    read_data(chA.getItem(i));

	    for (int j = 0; j < KB; j++) {
		if (KdSort[j] == null)
		    continue;
		KC[i][j] = new KeyData(KdSort[j]);
	    }
	}
	return cnt;
    }
    public double[] getIG(boolean sw) { // true:inha. false:grade
 	int cnt = AllCorr;
	double[] x = new double[cnt];
	for (int i = 0; i < cnt; i++) {
	    x[i] = (sw) ? IG[i].getInha() : IG[i].getGrade();
	}
	return x;
    }
    //
    public void calcCorre() {
	R = new double[KB];
	double[] x = getIG(false); // grade

	for (int k = 0; k < KB; k++) {
	    calcR(k);
	    calcCorrelation(x, Y);
	    R[k] = RR;
	}

	CorrSW = true;
    }
    public void calcR(int startK) {
	int ke;
	int endK = startK+2*OCTAVE;
	double y0, y1, k0; 
	int[] key;
	double[] cent;
	Y = new double[CorrCNT];

	for (int i = 0; i < CorrCNT; i++) {
	    key = new int[KB];
	    cent = new double[KB];

	    for (int j = 0; j < KB; j++) {
		if (KC[i][j] == null) // cnt:KB
		    continue;
		ke = KC[i][j].getKey()-1; // -1
		if (ke >= startK && ke <= endK) {
		    cent[ke] = KC[i][j].getCent();
		    key[ke] = ke;
		}
	    }
	    calcLSM(key, cent);
	    //System.out.println(lsmA+" : "+lsmB);
	    y1 = lsmA+lsmB*endK;
	    y0 = lsmA+lsmB*startK;
	    k0 = y1-y0;
	    Y[i] = k0;
	}
    }
    public void calcCorrelation(double x[], double[] y) {
	int n = x.length;
	double sx = 0;
	double sy = 0;
	double sxx = 0;
	double syy = 0;
	double sxy = 0;
	double sx2, sy2, c, r;
	for (int i = 0; i < n; i++) {
	    sx += x[i];
	    sy += y[i];
	    sxx += x[i]*x[i];
	    syy += y[i]*y[i];
	    sxy += x[i]*y[i];
	}

	sx2 = sx*sx;
	sy2 = sy*sy;
	c = (sxy-sx*sy/n)/(n-1);
	RR = (sxy-sx*sy/n)/Math.sqrt((sxx-sx2/n)*(syy-sy2/n)); // ط R
	//System.out.println("R: "+(float)RR);
    }
    //
    public double calcFreq(int par, int key) {
        return ctof(getFreq(key)*par, getICent(key, par));
    }
    public double ctof(double f, double c) {
        return f*Math.pow(2, c/CENT12);
    }
    public double getFreq(int key) {
        return 440*Math.pow(2, (key-48)*REVOCT); // 49-1
    }
    public double getICent(int key, int par) {
        return Inha[key]*par*par+Cent[key];
    }
    //
    public void dispIGdata(Graphics g) {
	double mini = 0.5; // inha.
	double maxi = 0.8;
	double sft = 0.4;
	double ming = 0.08;// grade
	double maxg = 0.1;
	double dx = (double)W/(ZOOMV*(maxi-mini));
	double dy = (double)H/(ZOOMH*(maxg-ming));
	double[] x = getIG(true); // inha.
	double[] y = getIG(false);// grade
	int x0, y0;

	dispIGlineH(g, mini, maxi, sft);
	dispIGlineV(g);
	dispIGminmax(g, x, y);

	g.setColor(Color.green);
	for (int i = 0; i < x.length; i++) {
	    y0 = (int)(H-(y[i]-HORI)*dy);
	    x0 = (int)((x[i]-VERT*0.1-sft)*dx);

	    g.fillOval(x0, y0, DOT, DOT);
	}
    }
    public void dispIGminmax(Graphics g, double[] x, double[] y) {
	MinMax mmx = new MinMax(x);
	double minx = mmx.getMin();
	double maxx = mmx.getMax();
	MinMax mmy = new MinMax(y);
	double miny = mmy.getMin();
	double maxy = mmy.getMax();

	g.setColor(Color.orange);
	g.drawString("Inha.:["+dform(minx)+"-"+dform(maxx)+"]", 1, FONT);
	g.setColor(Color.pink);
	g.drawString("Grade:["+dform(miny)+"-"+dform(maxy)+"]", 1, FONT*2);
    }
    public void dispIGlineH(Graphics g, double min, double max, double sft) {
	double dx = (double)W/(ZOOMV*10*(max-min));
	int x0;

	for (int i = 0; i < 10; i++) {
	    x0 = (int)(dx*(i-VERT)+SFT);
	    g.setColor(Color.darkGray);
	    g.drawLine(x0, 0, x0, H);

	    g.setColor(Color.orange);
	    g.drawString(dform(0.1*i+sft), x0, H);
	}
    }
    public void dispIGlineV(Graphics g) {
	double min = 0.05; // not0.08 double max = 0.1;
	double y0;
	int yy;
	int l = fm.stringWidth("0.00");
	double dy = (double)H/(ZOOMH*0.02);

	for (int i = 0; i < 10; i++) {
	    y0 = min+i*0.01;
	    yy = (int)(H-dy*(y0-HORI)+SFT);

	    g.setColor(Color.darkGray);
	    g.drawLine(0, yy, W, yy);

	    g.setColor(Color.pink);
	    g.drawString(dform(y0), W-l, yy);
	}
    }
}
